## pyzmq 26.2.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.14...3.28)
project(${SKBUILD_PROJECT_NAME} LANGUAGES C CXX)
set(CMAKE_POLICY_DEFAULT_CMP0077 NEW)

list(PREPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake)
find_package(
  Python
  COMPONENTS Interpreter Development.Module
  REQUIRED)

# Python_SOABI isn't always right when cross-compiling
# SKBUILD_SOABI seems to be
if (DEFINED SKBUILD_SOABI AND NOT "${SKBUILD_SOABI}" STREQUAL "${Python_SOABI}")
  message(WARNING "SKBUILD_SOABI=${SKBUILD_SOABI} != Python_SOABI=${Python_SOABI}; likely cross-compiling, using SOABI=${SKBUILD_SOABI} from scikit-build")
  set(Python_SOABI "${SKBUILD_SOABI}")
endif()

# legacy pyzmq env options, no PYZMQ_ prefix
set(ZMQ_PREFIX "auto" CACHE STRING "libzmq installation prefix or 'bundled'")
option(ZMQ_DRAFT_API "whether to build the libzmq draft API" OFF)
option(PYZMQ_LIBZMQ_RPATH "Add $ZMQ_PREFIX/lib to $RPATH (true by default). Set to false if libzmq will be bundled or relocated and RPATH is handled separately" ON)

# anything new should start with PYZMQ_
option(PYZMQ_NO_BUNDLE "Prohibit building bundled libzmq. Useful for repackaging, to allow default search for libzmq and requiring it to succeed." OFF)
set(PYZMQ_LIBZMQ_VERSION "4.3.5" CACHE STRING "libzmq version when bundling")
set(PYZMQ_LIBSODIUM_VERSION "1.0.20" CACHE STRING "libsodium version when bundling")
set(PYZMQ_LIBZMQ_URL "" CACHE STRING "full URL to download bundled libzmq")
set(PYZMQ_LIBSODIUM_URL "" CACHE STRING "full URL to download bundled libsodium")
set(PYZMQ_LIBSODIUM_CONFIGURE_ARGS "" CACHE STRING "semicolon-separated list of arguments to pass to ./configure for bundled libsodium")
set(PYZMQ_LIBSODIUM_MSBUILD_ARGS "" CACHE STRING "semicolon-separated list of arguments to pass to msbuild for bundled libsodium")
set(PYZMQ_LIBSODIUM_VS_VERSION "" CACHE STRING "Visual studio solution version for bundled libsodium (default: detect from MSVC_VERSION)")

if (NOT CMAKE_BUILD_TYPE)
  # default to Release
  set(CMAKE_BUILD_TYPE "Release")
endif()

# get options from env

# handle booleans
foreach(_optname ZMQ_DRAFT_API PYZMQ_NO_BUNDLE PYZMQ_LIBZMQ_RPATH)
  if (DEFINED ENV{${_optname}})
    if ("$ENV{${_optname}}" STREQUAL "1" OR "$ENV{${_optname}}" STREQUAL "ON")
      set(${_optname} TRUE)
    else()
      set(${_optname} FALSE)
    endif()
  endif()
endforeach()

foreach(_optname
  ZMQ_PREFIX
  PYZMQ_LIBZMQ_VERSION
  PYZMQ_LIBZMQ_URL
  PYZMQ_LIBSODIUM_VERSION
  PYZMQ_LIBSODIUM_URL
  PYZMQ_LIBSODIUM_CONFIGURE_ARGS
  PYZMQ_LIBSODIUM_MSBUILD_ARGS
  PYZMQ_LIBSODIUM_VS_VERSION
)
  if (DEFINED ENV{${_optname}})
    if (_optname MATCHES ".*_ARGS")
      # if it's an _ARGS, split "-a -b" into "-a" "-b"
      # use native CMake lists for cmake args,
      # native command-line strings for env variables
      separate_arguments(${_optname} NATIVE_COMMAND "$ENV{${_optname}}")
    else()
      set(${_optname} "$ENV{${_optname}}")
    endif()
  endif()
endforeach()

if(ZMQ_DRAFT_API)
  message(STATUS "enabling ZMQ_DRAFT_API")
  add_compile_definitions(ZMQ_BUILD_DRAFT_API=1)
endif()

if (PYZMQ_LIBSODIUM_VERSION AND NOT PYZMQ_LIBSODIUM_URL)
  set(PYZMQ_LIBSODIUM_URL "https://github.com/jedisct1/libsodium/releases/download/${PYZMQ_LIBSODIUM_VERSION}-RELEASE/libsodium-${PYZMQ_LIBSODIUM_VERSION}.tar.gz")
endif()

if (PYZMQ_LIBZMQ_VERSION AND NOT PYZMQ_LIBZMQ_URL)
  set(PYZMQ_LIBZMQ_URL "https://github.com/zeromq/libzmq/releases/download/v${PYZMQ_LIBZMQ_VERSION}/zeromq-${PYZMQ_LIBZMQ_VERSION}.tar.gz")
endif()

#------- bundle libzmq ------

if (NOT ZMQ_PREFIX)
  # empty string is the same as 'auto'
  set(ZMQ_PREFIX "auto")
endif()

# default search paths:

foreach(prefix $ENV{PREFIX} "/opt/homebrew" "/opt/local" "/usr/local" "/usr")
  if (IS_DIRECTORY "${prefix}")
    list(APPEND CMAKE_PREFIX_PATH "${prefix}")
  endif()
endforeach()

if (ZMQ_PREFIX STREQUAL "auto")
  message(CHECK_START "Looking for libzmq")
  find_package(ZeroMQ QUIET)
  if (ZeroMQ_FOUND AND TARGET libzmq)
    set(libzmq_target "libzmq")
    get_target_property(_ZMQ_LOCATION libzmq IMPORTED_LOCATION)
    message(CHECK_PASS "Found with cmake: ${_ZMQ_LOCATION}")
  endif()

  if (NOT ZeroMQ_FOUND)
    find_package(PkgConfig QUIET)
    if (PkgConfig_FOUND)
      message(CHECK_START "Looking for libzmq with pkg-config")
      pkg_check_modules(libzmq libzmq IMPORTED_TARGET)
      if (TARGET PkgConfig::libzmq)
        set(ZeroMQ_FOUND TRUE)
        set(libzmq_target "PkgConfig::libzmq")
        message(CHECK_PASS "found: -L${libzmq_LIBRARY_DIRS} -l${libzmq_LIBRARIES}")
        if (PYZMQ_LIBZMQ_RPATH)
          foreach(LIBZMQ_LIB_DIR IN LISTS libzmq_LIBRARY_DIRS)
            message(STATUS "  Adding ${LIBZMQ_LIB_DIR} to RPATH, set PYZMQ_LIBZMQ_RPATH=OFF if this is not what you want.")
            list(APPEND CMAKE_INSTALL_RPATH "${LIBZMQ_LIB_DIR}")
          endforeach()
        endif()
      else()
        message(CHECK_FAIL "no")
      endif()
    endif()
  endif()

  if (NOT ZeroMQ_FOUND)
    message(STATUS "  Fallback: looking for libzmq in ${CMAKE_PREFIX_PATH}")
    find_library(LIBZMQ_LIBRARY NAMES zmq)
    find_path(LIBZMQ_INCLUDE_DIR "zmq.h")

    # check if found
    if (LIBZMQ_LIBRARY AND LIBZMQ_INCLUDE_DIR)
      set(ZeroMQ_FOUND TRUE)
      message(CHECK_PASS "${LIBZMQ_LIBRARY}")
      # NOTE: we _could_ set RPATH here. Should we? Unclear.
      if (PYZMQ_LIBZMQ_RPATH)
        get_filename_component(LIBZMQ_LIB_DIR "${LIBZMQ_LIBRARY}" DIRECTORY)
        message(STATUS "  Adding ${LIBZMQ_LIB_DIR} to RPATH, set PYZMQ_LIBZMQ_RPATH=OFF if this is not what you want.")
        list(APPEND CMAKE_INSTALL_RPATH "${LIBZMQ_LIB_DIR}")
      endif()
    endif()
  endif()

  if (NOT ZeroMQ_FOUND)
    if (PYZMQ_NO_BUNDLE)
      message(CHECK_FAIL "libzmq not found")
      message(FATAL_ERROR "aborting because bundled libzmq is disabled")
    else()
      message(CHECK_FAIL "libzmq not found, will bundle libzmq and libsodium")
      set(ZMQ_PREFIX "bundled")
    endif()
  endif()
elseif (NOT ZMQ_PREFIX STREQUAL "bundled")
  message(CHECK_START "Looking for libzmq in ${ZMQ_PREFIX}")
  find_path(
    LIBZMQ_INCLUDE_DIR zmq.h
    PATHS "${ZMQ_PREFIX}/include"
    NO_DEFAULT_PATH
  )
  find_library(
    LIBZMQ_LIBRARY
    NAMES zmq
    PATHS "${ZMQ_PREFIX}/lib"
    NO_DEFAULT_PATH
  )
  if (LIBZMQ_LIBRARY AND LIBZMQ_INCLUDE_DIR)
    message(CHECK_PASS "${LIBZMQ_LIBRARY}")
    if (PYZMQ_LIBZMQ_RPATH)
      # add prefix to RPATH
      message(STATUS "  Adding ${ZMQ_PREFIX}/lib to RPATH, set PYZMQ_LIBZMQ_RPATH=OFF if this is not what you want.")
      list(APPEND CMAKE_INSTALL_RPATH "${ZMQ_PREFIX}/lib")
    endif()
  else()
    message(CHECK_FAIL "no")
    message(FATAL_ERROR "libzmq not found in ZMQ_PREFIX=${ZMQ_PREFIX}")
  endif()
else()
  # bundled
endif()

if (ZMQ_PREFIX STREQUAL "bundled")
  message(STATUS "Bundling libzmq and libsodium")
  include(FetchContent)
  add_compile_definitions(ZMQ_STATIC=1)
  set(BUNDLE_DIR "${CMAKE_CURRENT_BINARY_DIR}/bundled")
  file(MAKE_DIRECTORY "${BUNDLE_DIR}/lib")
  include_directories(${BUNDLE_DIR}/include)
  list(PREPEND CMAKE_PREFIX_PATH ${BUNDLE_DIR})

  set(LICENSE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/licenses")
  file(MAKE_DIRECTORY "${LICENSE_DIR}")

  # libsodium

  if (MSVC)
    set(libsodium_lib "${BUNDLE_DIR}/lib/libsodium.lib")
  else()
    set(libsodium_lib "${BUNDLE_DIR}/lib/libsodium.a")
  endif()

  FetchContent_Declare(bundled_libsodium
    URL ${PYZMQ_LIBSODIUM_URL}
    PREFIX ${BUNDLE_DIR}
  )
  FetchContent_MakeAvailable(bundled_libsodium)
  configure_file("${bundled_libsodium_SOURCE_DIR}/LICENSE" "${LICENSE_DIR}/LICENSE.libsodium.txt" COPYONLY)
  # run libsodium build explicitly here, so it's available to libzmq next
  set(bundled_libsodium_include "${bundled_libsodium_SOURCE_DIR}/src/libsodium/include")

  if(${bundled_libsodium_POPULATED} AND NOT EXISTS "${libsodium_lib}")
    message(STATUS "building bundled libsodium")
    if (MSVC)
      # select vs build solution by msvc version number
      if (NOT PYZMQ_LIBSODIUM_VS_VERSION)
        if(MSVC_VERSION GREATER_EQUAL 1940)
          message(STATUS "Unrecognized MSVC_VERSION=${MSVC_VERSION}")
          set(MSVC_VERSION 1939)
        endif()

        if(MSVC_VERSION GREATER_EQUAL 1930)
          set(PYZMQ_LIBSODIUM_VS_VERSION "2022")
        elseif(MSVC_VERSION GREATER_EQUAL 1920)
          set(PYZMQ_LIBSODIUM_VS_VERSION "2019")
        elseif(MSVC_VERSION GREATER_EQUAL 1910)
          set(PYZMQ_LIBSODIUM_VS_VERSION "2017")
        else()
          message(FATAL_ERROR "unsupported bundling libsodium for MSVC_VERSION=${MSVC_VERSION} (need at least VS2017)")
        endif()
      endif()
      find_package(Vcvars REQUIRED)
      list(APPEND libsodium_build
        ${Vcvars_LAUNCHER}
        "msbuild"
        "/m"
        "/v:n"
        "/p:Configuration=Static${CMAKE_BUILD_TYPE}"
        "/p:Platform=${CMAKE_GENERATOR_PLATFORM}"
        "builds/msvc/vs${PYZMQ_LIBSODIUM_VS_VERSION}/libsodium.sln"
      )
      list(APPEND libsodium_build ${PYZMQ_LIBSODIUM_MSBUILD_ARGS})
      execute_process(
        COMMAND ${libsodium_build}
        WORKING_DIRECTORY ${bundled_libsodium_SOURCE_DIR}
        COMMAND_ECHO STDOUT
        # COMMAND_ERROR_IS_FATAL ANY
        RESULT_VARIABLE _status
      )
      if (_status) 
        message(FATAL_ERROR "failed to build libsodium")
      endif()
      file(GLOB_RECURSE BUILT_LIB "${bundled_libsodium_SOURCE_DIR}/**/libsodium.lib")
      message(STATUS "copy ${BUILT_LIB} ${libsodium_lib}")
      configure_file(${BUILT_LIB} ${libsodium_lib} COPYONLY)
    else()
      list(APPEND libsodium_configure
        ./configure
        --prefix=${BUNDLE_DIR}
        --with-pic
        --disable-dependency-tracking
        --disable-shared
        --enable-static
      )
      list(APPEND libsodium_configure ${PYZMQ_LIBSODIUM_CONFIGURE_ARGS})
      execute_process(
        COMMAND ${libsodium_configure}
        WORKING_DIRECTORY ${bundled_libsodium_SOURCE_DIR}
        COMMAND_ECHO      STDOUT
        # COMMAND_ERROR_IS_FATAL ANY
        RESULT_VARIABLE _status
      )
      # COMMAND_ERROR_IS_FATAL requires cmake 3.19, ubuntu 20.04 has 3.16
      if (_status) 
        message(FATAL_ERROR "failed to configure libsodium")
      endif()
      execute_process(
        COMMAND make
        WORKING_DIRECTORY ${bundled_libsodium_SOURCE_DIR}
        COMMAND_ECHO STDOUT
        # COMMAND_ERROR_IS_FATAL ANY
        RESULT_VARIABLE _status
      )
      if (_status) 
        message(FATAL_ERROR "failed to build libsodium")
      endif()
      execute_process(
        COMMAND make install
        WORKING_DIRECTORY ${bundled_libsodium_SOURCE_DIR}
        COMMAND_ECHO STDOUT
        # COMMAND_ERROR_IS_FATAL ANY
        RESULT_VARIABLE _status
      )
      if (_status) 
        message(FATAL_ERROR "failed to install libsodium")
      endif()
    endif()
  endif()

  # use libzmq's own cmake, so we can import the libzmq-static target
  set(ENABLE_CURVE ON)
  set(ENABLE_DRAFTS ${ZMQ_DRAFT_API})
  set(ENABLE_LIBSODIUM_RANDOMBYTES_CLOSE "OFF")
  set(WITH_LIBSODIUM ON)
  set(WITH_LIBSODIUM_STATIC ON)
  set(LIBZMQ_PEDANTIC OFF)
  set(LIBZMQ_WERROR OFF)
  set(WITH_DOC OFF)
  set(WITH_DOCS OFF)
  set(BUILD_TESTS OFF)
  set(BUILD_SHARED OFF)
  set(BUILD_STATIC ON)

  if(NOT MSVC)
    # backport check for kqueue, which is wrong in libzmq 4.3.5
    # libzmq's cmake will proceed with the rest
    # https://github.com/zeromq/libzmq/pull/4659
    include(CheckCXXSymbolExists)
    set(POLLER
      ""
      CACHE STRING "Choose polling system for I/O threads. valid values are
    kqueue, epoll, devpoll, pollset, poll or select [default=autodetect]")
    if(POLLER STREQUAL "")
      check_cxx_symbol_exists(kqueue "sys/types.h;sys/event.h;sys/time.h" HAVE_KQUEUE)
      if(HAVE_KQUEUE)
        set(POLLER "kqueue")
      endif()
    endif()
  endif()

  if(MSVC)
    set(API_POLLER "select" CACHE STRING "Set API Poller (default: select)")
  endif()

  FetchContent_Declare(bundled_libzmq
    URL ${PYZMQ_LIBZMQ_URL}

=== debian/changelog ===
pyzmq (26.2.1-1build1) plucky; urgency=medium

  * No-change rebuild with Python 3.13 only

 -- Graham Inggs <ginggs@ubuntu.com>  Tue, 04 Mar 2025 19:33:01 +0000

pyzmq (26.2.1-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.

 -- Colin Watson <cjwatson@debian.org>  Mon, 03 Feb 2025 17:36:43 +0000

## pyzmq 26.4.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -29,6 +29,7 @@
 set(PYZMQ_LIBSODIUM_CONFIGURE_ARGS "" CACHE STRING "semicolon-separated list of arguments to pass to ./configure for bundled libsodium")
 set(PYZMQ_LIBSODIUM_MSBUILD_ARGS "" CACHE STRING "semicolon-separated list of arguments to pass to msbuild for bundled libsodium")
 set(PYZMQ_LIBSODIUM_VS_VERSION "" CACHE STRING "Visual studio solution version for bundled libsodium (default: detect from MSVC_VERSION)")
+set(PYZMQ_BACKEND "" CACHE STRING "pyzmq backend to build ('cffi' or 'cython'). Default: cffi on PyPy, else Cython.")
 
 if (NOT CMAKE_BUILD_TYPE)
   # default to Release
@@ -57,6 +58,7 @@
   PYZMQ_LIBSODIUM_CONFIGURE_ARGS
   PYZMQ_LIBSODIUM_MSBUILD_ARGS
   PYZMQ_LIBSODIUM_VS_VERSION
+  PYZMQ_BACKEND
 )
   if (DEFINED ENV{${_optname}})
     if (_optname MATCHES ".*_ARGS")
@@ -301,6 +303,16 @@
   endif()
 
   # use libzmq's own cmake, so we can import the libzmq-static target
+  # libzmq uses an ancient policy minimum, no longer supported
+  if ("${CMAKE_POLICY_VERSION_MINIMUM}" STREQUAL "")
+    # workaround https://github.com/zeromq/libzmq/pull/4776
+    if (CMAKE_VERSION VERSION_GREATER_EQUAL "3.31")
+      set(CMAKE_POLICY_VERSION_MINIMUM "3.31")
+    else()
+      set(CMAKE_POLICY_VERSION_MINIMUM "${CMAKE_VERSION_MAJOR}.${CMAKE_VERSION_MINOR}")
+    endif()
+    message(STATUS "Setting CMAKE_POLICY_VERSION_MINIMUM=${CMAKE_POLICY_VERSION_MINIMUM} for libzmq")
+  endif()
   set(ENABLE_CURVE ON)
   set(ENABLE_DRAFTS ${ZMQ_DRAFT_API})
   set(ENABLE_LIBSODIUM_RANDOMBYTES_CLOSE "OFF")
@@ -316,24 +328,3 @@
 
   if(NOT MSVC)
     # backport check for kqueue, which is wrong in libzmq 4.3.5
-    # libzmq's cmake will proceed with the rest
-    # https://github.com/zeromq/libzmq/pull/4659
-    include(CheckCXXSymbolExists)
-    set(POLLER
-      ""
-      CACHE STRING "Choose polling system for I/O threads. valid values are
-    kqueue, epoll, devpoll, pollset, poll or select [default=autodetect]")
-    if(POLLER STREQUAL "")
-      check_cxx_symbol_exists(kqueue "sys/types.h;sys/event.h;sys/time.h" HAVE_KQUEUE)
-      if(HAVE_KQUEUE)
-        set(POLLER "kqueue")
-      endif()
-    endif()
-  endif()
-
-  if(MSVC)
-    set(API_POLLER "select" CACHE STRING "Set API Poller (default: select)")
-  endif()
-
-  FetchContent_Declare(bundled_libzmq
-    URL ${PYZMQ_LIBZMQ_URL}

=== docs/requirements.txt ===
cython>=0.29
enum-tools[sphinx]>=0.9
gevent
myst-parser[linkify]
pydata_sphinx_theme
pygments>=2.6
sphinx>=3.0.4
tornado

=== perf/Makefile ===
BASE_IMAGE=python:3.11
IMAGE=pyzmq-perf
VOLUME=pyzmq-perf

ifeq ("$(DOCKER_MACHINE_NAME)", "")
	OUT_PATH=$(PWD)
	FETCH=true
else
	OUT_PATH=/tmp/data
	FETCH=docker-machine scp $(DOCKER_MACHINE_NAME):$(OUT_PATH)/*.pickle ./
endif

RUN=docker run --rm -v $(VOLUME):/data -it $(IMAGE)

build:
	docker build -t $(IMAGE) .

volume:
	docker volume inspect pyzmq-perf &> /dev/null || docker volume create $(VOLUME)

rm-volume:
	- docker volume rm pyzmq-perf

thr:
	$(RUN) thr
	# fill in 10k-100k for the crossover
	$(RUN) thr --min 4 --max 5 --points 6
lat:
	$(RUN) lat

run: build volume thr lat

get-data:
	docker run --rm -v $(OUT_PATH):/out/ -v $(VOLUME):/data -it $(BASE_IMAGE) sh -c 'cp /data/* /out/'
	$(FETCH)

=== debian/changelog ===
pyzmq (26.4.0-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.

 -- Colin Watson <cjwatson@debian.org>  Mon, 05 May 2025 17:05:38 +0100

## pyzmq 27.1.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,17 +1,30 @@
-cmake_minimum_required(VERSION 3.14...3.28)
+cmake_minimum_required(VERSION 3.14...4.1)
 project(${SKBUILD_PROJECT_NAME} LANGUAGES C CXX)
 set(CMAKE_POLICY_DEFAULT_CMP0077 NEW)
 
 list(PREPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake)
+message(STATUS "Building pyzmq for ${CMAKE_SYSTEM_NAME} ${CMAKE_SYSTEM_VERSION}")
+
+if(ANDROID)
+  # Android seems to need to link libpython,
+  # which means Development.Embed
+  set(EXTRA_PYTHON_COMPONENT "Development.Embed")
+endif()
+
 find_package(
   Python
-  COMPONENTS Interpreter Development.Module
-  REQUIRED)
+  COMPONENTS
+    Interpreter
+    Development.Module
+    ${EXTRA_PYTHON_COMPONENT}
+    ${SKBUILD_SABI_COMPONENT}
+  REQUIRED
+)
 
 # Python_SOABI isn't always right when cross-compiling
 # SKBUILD_SOABI seems to be
 if (DEFINED SKBUILD_SOABI AND NOT "${SKBUILD_SOABI}" STREQUAL "${Python_SOABI}")
-  message(WARNING "SKBUILD_SOABI=${SKBUILD_SOABI} != Python_SOABI=${Python_SOABI}; likely cross-compiling, using SOABI=${SKBUILD_SOABI} from scikit-build")
+  message(WARNING "SKBUILD_SOABI=${SKBUILD_SOABI} != Python_SOABI=${Python_SOABI}; likely cross-compiling or Limited API, using SOABI=${SKBUILD_SOABI} from scikit-build")
   set(Python_SOABI "${SKBUILD_SOABI}")
 endif()
 
@@ -267,6 +280,15 @@
         --disable-shared
         --enable-static
       )
+
+      # add --host for cross compiling
+      message(STATUS "Cross: ${CMAKE_CROSSCOMPILING} $ENV{CIBW_HOST_TRIPLET}")
+      if(CMAKE_CROSSCOMPILING AND DEFINED ENV{CIBW_HOST_TRIPLET})
+        message(STATUS "Cross compiling libsodium for host: $ENV{CIBW_HOST_TRIPLET}")
+        list(APPEND libsodium_configure "--host=$ENV{CIBW_HOST_TRIPLET}")
+        message(STATUS "Cross compiling libsodium for host: $ENV{CIBW_HOST_TRIPLET} ${libsodium_configure}")
+      endif()
+
       list(APPEND libsodium_configure ${PYZMQ_LIBSODIUM_CONFIGURE_ARGS})
       execute_process(
         COMMAND ${libsodium_configure}
@@ -305,26 +327,3 @@
   # use libzmq's own cmake, so we can import the libzmq-static target
   # libzmq uses an ancient policy minimum, no longer supported
   if ("${CMAKE_POLICY_VERSION_MINIMUM}" STREQUAL "")
-    # workaround https://github.com/zeromq/libzmq/pull/4776
-    if (CMAKE_VERSION VERSION_GREATER_EQUAL "3.31")
-      set(CMAKE_POLICY_VERSION_MINIMUM "3.31")
-    else()
-      set(CMAKE_POLICY_VERSION_MINIMUM "${CMAKE_VERSION_MAJOR}.${CMAKE_VERSION_MINOR}")
-    endif()
-    message(STATUS "Setting CMAKE_POLICY_VERSION_MINIMUM=${CMAKE_POLICY_VERSION_MINIMUM} for libzmq")
-  endif()
-  set(ENABLE_CURVE ON)
-  set(ENABLE_DRAFTS ${ZMQ_DRAFT_API})
-  set(ENABLE_LIBSODIUM_RANDOMBYTES_CLOSE "OFF")
-  set(WITH_LIBSODIUM ON)
-  set(WITH_LIBSODIUM_STATIC ON)
-  set(LIBZMQ_PEDANTIC OFF)
-  set(LIBZMQ_WERROR OFF)
-  set(WITH_DOC OFF)
-  set(WITH_DOCS OFF)
-  set(BUILD_TESTS OFF)
-  set(BUILD_SHARED OFF)
-  set(BUILD_STATIC ON)
-
-  if(NOT MSVC)
-    # backport check for kqueue, which is wrong in libzmq 4.3.5

=== docs/Makefile ===
# Makefile for Sphinx documentation
#

# You can set these variables from the command line.
SPHINXOPTS    ?= -n
SPHINXBUILD   ?= sphinx-build
PAPER         ?=
BUILDDIR      ?= build
SRCDIR        ?= source

# Internal variables.
PAPEROPT_a4     = -D latex_paper_size=a4
PAPEROPT_letter = -D latex_paper_size=letter
ALLSPHINXOPTS   = -d $(BUILDDIR)/doctrees $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) $(SRCDIR)

.PHONY: help clean html dirhtml pickle json htmlhelp qthelp latex changes linkcheck doctest

default: html

help:
	@echo "Please use \`make <target>' where <target> is one of"
	@echo "  html      to make standalone HTML files"
	@echo "  dirhtml   to make HTML files named index.html in directories"
	@echo "  pickle    to make pickle files"
	@echo "  json      to make JSON files"
	@echo "  htmlhelp  to make HTML files and a HTML help project"
	@echo "  qthelp    to make HTML files and a qthelp project"
	@echo "  latex     to make LaTeX files, you can set PAPER=a4 or PAPER=letter"
	@echo "  changes   to make an overview of all changed/added/deprecated items"
	@echo "  linkcheck to check all external links for integrity"
	@echo "  doctest   to run all doctests embedded in the documentation (if enabled)"

clean:
	-rm -rf $(BUILDDIR)/*
	-rm -rf $(SRCDIR)/api/generated/*
	-rm -rf dist
	-rm -rf gh-pages

api: $(SRCDIR)/api/generated/gen.rst

$(SRCDIR)/api/generated/gen.rst:
	python autogen_api.py
	@echo "Build API docs finished."

dist: all
	mkdir -p dist
	rm -rf dist/*
	ln $(BUILDDIR)/latex/PyZMQ.pdf dist/
	cp -a $(BUILDDIR)/html dist/
	@echo "Build finished.  Final docs are in dist/"

pdf: latex
	cd $(BUILDDIR)/latex && make all-pdf

all: html pdf

html:
	$(SPHINXBUILD) -b html $(ALLSPHINXOPTS) $(BUILDDIR)/html
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/html."

dirhtml:
	$(SPHINXBUILD) -b dirhtml $(ALLSPHINXOPTS) $(BUILDDIR)/dirhtml
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/dirhtml."

pickle:
	$(SPHINXBUILD) -b pickle $(ALLSPHINXOPTS) $(BUILDDIR)/pickle
	@echo
	@echo "Build finished; now you can process the pickle files."

json:
	$(SPHINXBUILD) -b json $(ALLSPHINXOPTS) $(BUILDDIR)/json
	@echo
	@echo "Build finished; now you can process the JSON files."

htmlhelp:
	$(SPHINXBUILD) -b htmlhelp $(ALLSPHINXOPTS) $(BUILDDIR)/htmlhelp
	@echo
	@echo "Build finished; now you can run HTML Help Workshop with the" \
	      ".hhp project file in $(BUILDDIR)/htmlhelp."

qthelp:
	$(SPHINXBUILD) -b qthelp $(ALLSPHINXOPTS) $(BUILDDIR)/qthelp
	@echo
	@echo "Build finished; now you can run "qcollectiongenerator" with the" \
	      ".qhcp project file in $(BUILDDIR)/qthelp, like this:"
	@echo "# qcollectiongenerator $(BUILDDIR)/qthelp/PyZMQ.qhcp"
	@echo "To view the help file:"
	@echo "# assistant -collectionFile $(BUILDDIR)/qthelp/PyZMQ.qhc"

latex: api
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo
	@echo "Build finished; the LaTeX files are in $(BUILDDIR)/latex."
	@echo "Run \`make all-pdf' or \`make all-ps' in that directory to" \
	      "run these through (pdf)latex."

changes:
	$(SPHINXBUILD) -b changes $(ALLSPHINXOPTS) $(BUILDDIR)/changes
	@echo
	@echo "The overview file is in $(BUILDDIR)/changes."

linkcheck:
	$(SPHINXBUILD) -b linkcheck $(ALLSPHINXOPTS) $(BUILDDIR)/linkcheck
	@echo
	@echo "Link check complete; look for any errors in the above output " \
	      "or in $(BUILDDIR)/linkcheck/output.txt."

doctest:
	$(SPHINXBUILD) -b doctest $(ALLSPHINXOPTS) $(BUILDDIR)/doctest
	@echo "Testing of doctests in the sources finished, look at the " \
	      "results in $(BUILDDIR)/doctest/output.txt."

gh-pages: html
	sh update_ghpages.sh

=== debian/changelog ===
pyzmq (27.1.0-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.

 -- Colin Watson <cjwatson@debian.org>  Tue, 09 Sep 2025 17:34:11 +0100

=== debian/control ===
Source: pyzmq
Section: python
Priority: optional
Maintainer: Debian Python Team <team+python@tracker.debian.org>
Uploaders: Julian Taylor <jtaylor.debian@googlemail.com>,
           Vincent Bernat <bernat@debian.org>,
           Laszlo Boszormenyi (GCS) <gcs@debian.org>
Build-Depends: cmake,
               cython3 (>= 3.0.0),
               debhelper-compat (= 13),
               dh-python,
               libzmq3-dev,
               pybuild-plugin-pyproject,
               python3-all-dev,
               python3-cffi <!nocheck>,
               python3-numpy <!nocheck>,
               python3-pytest <!nocheck>,
               python3-pytest-asyncio <!nocheck>,
               python3-pytest-rerunfailures <!nocheck>,
               python3-scikit-build-core,
               python3-tornado <!nocheck>,
Standards-Version: 4.6.2
Homepage: https://www.zeromq.org/bindings:python
Vcs-Git: https://salsa.debian.org/python-team/packages/pyzmq.git
Vcs-Browser: https://salsa.debian.org/python-team/packages/pyzmq
Rules-Requires-Root: no

Package: python3-zmq
Architecture: any
Depends: ${misc:Depends}, ${python3:Depends}, ${shlibs:Depends}
Description: Python3 bindings for 0MQ library
 Python bindings for 0MQ. 0MQ is a small, fast, and free
 software library that gives you message-passing concurrency
 for applications in most common languages.
 .
 The 0MQ lightweight messaging kernel is a library which
 extends the standard socket interfaces with features
 traditionally provided by specialised messaging middleware
 products. 0MQ sockets provide an abstraction of asynchronous
 message queues, multiple messaging patterns, message
 filtering (subscriptions), seamless access to multiple
 transport protocols and more.
 .
 This package contains the extension built for the Python3 interpreter.

=== debian/rules ===
#!/usr/bin/make -f

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

ARCHITECTURE := $(shell dpkg-architecture -qDEB_HOST_ARCH)
export PYBUILD_DESTDIR_python3=debian/python3-zmq/
export PYBUILD_DEBUG=1
# ignore that randomly hang or crash (gh-953)
export PYBUILD_TEST_ARGS=-v -k 'not (test_auth or test_log or test_cython)'
export DH_VERBOSE=1

%:
	dh $@ --with python3 --buildsystem=pybuild

override_dh_install:
	dh_install
	# remove cffi
	rm -rf debian/python3-zmq/usr/lib/python*/dist-packages/zmq/backend/cffi/

	find debian/python3-zmq -depth -type d -empty -delete

override_dh_auto_test:
# hard to debug race condition in monitor sockets
ifneq (,$(filter $(ARCHITECTURE), mipsel mips))
	-dh_auto_test -- --test-pytest
else
	dh_auto_test -- --test-pytest
endif

=== debian/tests/control ===
Tests: python3
Depends: python3-all,
         python3-numpy,
         python3-pytest,
         python3-pytest-asyncio,
         python3-pytest-rerunfailures,
         python3-tornado,
         python3-zmq,
Restrictions: allow-stderr

=== debian/watch ===
version=4
opts=uversionmangle=s/(\d)[_\.\-\+]?((RC|rc|pre|dev|beta|alpha|b|a)[\-\.]?\d*)$/$1~$2/ \
     https://github.com/zeromq/pyzmq/tags (?:.*?/)?v?(\d[\d.]*)\.tar\.gz
